#!/usr/bin/env python
import Tkinter
from Tkinter import *
import tkMessageBox
import webbrowser
import os
import socket

def credits():
	if lang=="ESP":
		tkMessageBox.showinfo("pyFirmCatcher Linux version","Version: 3.5 \n\nAutor: Grandir\n\nColaboradores: Martinatleti, Arceusgod12, Leomega y Yeoop")
	elif lang=="ENG":
		tkMessageBox.showinfo("pyFirmCatcher Linux version","Version: 3.5 \n\nAuthor: Grandir\n\nCollaborators: Martinatleti, Arceusgod12, Leomega y Yeoop")

def info1():
	f1=open("databases/NDS.txt", "r")
	f=Lb1.curselection()

	for line in f1:
		
		line=line.split()
		if f[0]==line[0]:
			if ser=="Mediafire":
				webbrowser.open(line[2])
			elif ser=="Megaupload":
				webbrowser.open(line[3])
def info2():
	f1=open("databases/WII.txt", "r")
	f=Lb2.curselection()

	for line in f1:
		
		line=line.split()
		if f[0]==line[0]:
			if ser=="Mediafire":
				webbrowser.open(line[2])
			elif ser=="Megaupload":
				webbrowser.open(line[3])



def ndsos():
	webbrowser.open("http://www.ndsos.net")
def wiisos():
	webbrowser.open("http://www.wiisos.com")
def ps3sos():
	webbrowser.open("http://www.ps3sos.com")
def x360sos():
	webbrowser.open("http://www.x360sos.com")


def tuto_flash():
	rut1=Tk()
	rut1.title("Tutorial para Flashcards")
	tutflash=Text(rut1)
	if lang=="ESP":
		tutflash.insert(INSERT, "1.- Descarga el paquete que necesites para tu Flashcard\n\n2.- Descomprime y copia el contenido del paquete a la raiz de la microSD\n\n3.- Sobreescribe los ficheros cuando te lo pida.\n\n4.- Listo, ya tienes el Firmware instalado en tu Flashcard.")
	elif lang=="ENG":
		tutflash.insert(INSERT, "1.- Download the desired package.\n\n2.- Unzip it and copy content into the root of your microSD card.\n\n3.- Overwrite files when prompted.\n\n4.- Done, you have the firmwware installed in your Flashcard.")
	tutflash.pack()

def chat_ndsos():
	webbrowser.open("http://ndsos2.chatango.com")
def chat_ps3sos():
	webbrowser.open("http://ps3-sos.chatango.com")
def chat_wiisos():
	webbrowser.open("http://wiisos2.chatango.com")
def chat_x360sos():
	webbrowser.open("http://x360sosl.chatango.com")

def tuto_loaders():
	rut=Tk()
	rut.title("Tutorial para Apps")
	tutloader=Text(rut)
	if lang=="ESP":
		tutloader.insert(INSERT, "1.- Descarga el paquete correspondiente.\n\n2.- Descomprime y copia la carpeta que contiene el paquete dentro de la carpeta 'apps' de la raiz de la targeta SD\n\n3.- Ejecuta el loader via Homebrew Channel\n\nNOTA: Estos pasos sirven para cualquier homebrew")
	elif lang=="ENG":
		tutloader.insert(INSERT, "1.- Download the corresponding package.\n\n2.- Unzip them and copy the folder contained in package into 'apps' folder in the root of SD card.\n\n3.- Launch it via Homebrew Channel\n\nNOTE: Those steps are valids to any homebrew.")
	tutloader.pack()

def mirror_sel_mf():
	global ser
	ser="Mediafire"
def mirror_sel_mu():
	global ser
	ser="Megaupload"
def sel_lang():
	w=open("options/LANG.txt", "r")
	lang0=w.readline()
	lang0=lang0.rstrip("\n")
	global lang
	lang=lang0
	w.close()

def set_lang_default_esp():
	w=open("options/LANG.txt", "w")
	w.write("ESP")
	w.close()
	tkMessageBox.showinfo("Aviso!", "Es necesario reiniciar el programa para que cambie el idioma por completo.")
def set_lang_default_eng():
	w=open("options/LANG.txt", "w")
	w.write("ENG")
	tkMessageBox.showinfo("Warning!", "It is necessary to restart this software to completely change language.")
	w.close()

def set_server_default_mu():
	w=open("options/SERVER.txt", "w")
	w.write("Megaupload")
	w.close()
	if lang=="ESP":
		tkMessageBox.showinfo("Aviso!", "Es necesario reiniciar el programa para que el cambio sea efectivo. O cambia el servidor temporalmente.")
	elif lang=="ENG":
		tkMessageBox.showinfo("Warning!", "You need to restart the program to be effective change. Or set a temporal server")
	

def set_server_default_mf():
	w=open("options/SERVER.txt", "w")
	w.write("Mediafire")
	w.close()
	

def sel_server():
	w=open("options/SERVER.txt", "r")
	ser0=w.readline()
	ser0=ser0.rstrip("\n")
	global ser
	ser=ser0
	w.close()

def IP_external():
	
	import re, urllib2
	s = urllib2.urlopen('http://www.showmyip.com/es').read()
	m = re.search('(?<=displaycopy).*', s) 
	ip = m.group(0)
	ip = ip.replace('("', '')
	ip = ip.replace('");', '')
	IP=[]
	for a in ip:
		if a=='.':
			IP.append(a)
		else:
			try:
				IP.append(int(a))
			except:
				pass
	IPIP=''
	for b in IP:
		IPIP=IPIP+str(b)
	return IPIP
root = Tk()
root.title("pySOSFirmCatcher")
photo_main=PhotoImage(file="images/image_center.gif")
B = Label(root, image=photo_main)
B.pack(side=RIGHT)


text = LabelFrame(root, text="pySOSFirmCatcher v3.5", width=500)
text.pack()

sel_lang()
sel_server()

if lang=="ESP":
	text2 = Label(text, text="Esta herramienta permite conseguir los diferentes firmwares de las consolas actuales.\n En esta version se incluyen Nintendo DS y Wii\n")
elif lang=="ENG":
	text2 = Label(text, text="This tool allow you to purchase a lot of different firmwares to curent videoconsoles.\n In this version, Nintendo DS and Wii are included\n")
text2.pack()
IP=socket.gethostbyname_ex(socket.gethostname())[2][0]
try:
	IP_ext=IP_external()
except:
	IP_ext='- - -'
if lang == "ESP":
	text_opt=LabelFrame(root, text="Opciones:", width=500)
	text_opt.pack(side=LEFT)
	text_opt_lang=Label(text_opt, text="Idioma: "+str(lang))
	text_opt_lang.pack()
	text_opt_mirror=Label(text_opt, text="Servidor: "+str(ser))
	text_opt_mirror.pack()
	text_opt_ip_local=Label(text_opt, text="IP Local: "+str(IP))
	text_opt_ip_local.pack()
	text_opt_ip_public=Label(text_opt, text="IP Publica: "+str(IP_ext))
	text_opt_ip_public.pack()

if lang == "ENG":
	text_opt=LabelFrame(root, text="Options:", width=500)
	text_opt.pack(side=LEFT)
	text_opt_lang=Label(text_opt, text="Language: "+str(lang))
	text_opt_lang.pack()
	text_opt_mirror=Label(text_opt, text="Server: "+str(ser))
	text_opt_mirror.pack()
	text_opt_ip=Label(text_opt, text="Local IP: "+str(IP))
	text_opt_ip.pack()
	text_opt_ip_public=Label(text_opt, text="Public IP: "+str(IP_ext))
	text_opt_ip_public.pack()

if lang=="ESP":
	text3 = LabelFrame(root, text="Cambia el servidor para esta sesion", width=500)
elif lang=="ENG":
	text3 = LabelFrame(root, text="Change server for this session.", width=500)
text3.pack()

var=IntVar()
photo_mf=PhotoImage(file="images/mf2.gif")
R1 = Radiobutton(text3, image=photo_mf, variable=var, value=1, command=mirror_sel_mf)
R1.pack(side=LEFT)
photo_mu=PhotoImage(file="images/mu2.gif")
R2 = Radiobutton(text3, image=photo_mu, variable=var, value=2, command=mirror_sel_mu)
R2.pack(side=RIGHT)

photo_ps3logo=PhotoImage(file="images/ps3logo.gif")
photo_wiilogo=PhotoImage(file="images/wiilogo.gif")
photo_360logo=PhotoImage(file="images/360logo.gif")
photo_ndslogo=PhotoImage(file="images/ndslogo.gif")
photo_ndslogo_chat=PhotoImage(file="images/ndslogochat.gif")
photo_ps3logo_chat=PhotoImage(file="images/ps3logochat.gif")
photo_wiilogo_chat=PhotoImage(file="images/wiilogochat.gif")
photo_360logo_chat=PhotoImage(file="images/360logochat.gif")
photo_mu_mini=PhotoImage(file="images/mu_mini.gif")
photo_mf_mini=PhotoImage(file="images/mf_mini.gif")

menubar = Menu(root)
filemenu = Menu(menubar, tearoff=0)
if lang=="ESP":
	filemenu.add_command(label="Creditos", command=credits)
	filemenu.add_command(label="Salir", command=root.quit)
	menubar.add_cascade(label="Archivo", menu=filemenu)
elif lang=="ENG":
	filemenu.add_command(label="About us", command=credits)
	filemenu.add_command(label="Exit", command=root.quit)
	menubar.add_cascade(label="File", menu=filemenu)



photo_esp=PhotoImage(file="images/esp.gif")
photo_eng=PhotoImage(file="images/eng.gif")

langmenu = Menu(menubar, tearoff=0)
langmenu.add_command(image=photo_esp, command=set_lang_default_esp)
langmenu.add_command(image=photo_eng, command=set_lang_default_eng)
if lang=="ESP":
	menubar.add_cascade(label="Idioma por defecto", menu=langmenu)
elif lang=="ENG":
	menubar.add_cascade(label="Default language", menu=langmenu)

servermenu=Menu(menubar, tearoff=0)
servermenu.add_command(image=photo_mf_mini, command=set_server_default_mf)
servermenu.add_command(image=photo_mu_mini, command=set_server_default_mu)
if lang=="ESP":
	menubar.add_cascade(label="Servidor por defecto", menu=servermenu)
elif lang=="ENG":
	menubar.add_cascade(label="Default server", menu=servermenu)

fr=Frame(root)
fr.pack()

text_info=Label(fr, text="Firms Flashcards NDS                                  Nintendo Wii")
text_info.pack()


G= Frame(root)
G.pack()

Sb1 = Scrollbar(G)
Lb1 = Listbox(G, yscrollcommand=Sb1.set)
b=1
f1=open("databases/NDS.txt", "r")
for a in f1:
	a=a.split()
	bu=a[1]
	Lb1.insert(b,bu)
	b=b+1
f1.close()
Lb1.pack(side=LEFT, fill=Y)
Sb1.pack(side=LEFT, fill=Y)
Sb1.config(command=Lb1.yview)
Sb2 = Scrollbar(G)
Lb2 = Listbox(G, yscrollcommand=Sb2.set)
b=1
f2=open("databases/WII.txt", "r")
for a in f2:
	a=a.split()
	bu=a[1]
	Lb2.insert(b,bu)
	b=b+1
f2.close()
Lb2.pack(side=LEFT, fill=Y)
Sb2.pack(side=RIGHT, fill=Y)
Sb2.config(command=Lb2.yview)
G1 = Frame(root)
G1.pack()
B = Button(G1, text="Descargas NDS", command=info1, width=10)
B.pack(side=LEFT)
K=Label(G1, width=10)
K.pack(side=LEFT)
B = Button(G1, text="Descargas Wii", command=info2, width=10)
B.pack(side=RIGHT)
G2=Frame(root)
G2.pack()
tutobutton=Button(G2, text="Tutorial Flashcard", command=tuto_flash, width=20 )
tutobutton.pack(side=LEFT)
tutobuttonloaders=Button(G2, text="Tutorial Apps", command=tuto_loaders, width=20 )
tutobuttonloaders.pack(side=RIGHT)

if lang=="ESP":
	webframe = LabelFrame(root, text="Webs del Team SOS. Visitalas para una informacion mas detallada", width=500)
elif lang=="ENG":
	webframe = LabelFrame(root, text="Team SOS Webs. Visit them to more detailed info", width=500)
webframe.pack()
webnds = Button(webframe, image=photo_ndslogo, command=ndsos, bg="white", height=50)
webnds.pack(side=LEFT)
webps3 = Button(webframe, image=photo_ps3logo, command=ps3sos, bg="white", height=50)
webps3.pack(side=LEFT)
webwii = Button(webframe, image=photo_wiilogo, command=wiisos, bg="white", height=50)
webwii.pack(side=LEFT)
web360 = Button(webframe, image=photo_360logo, command=x360sos, bg="white", height=50)
web360.pack(side=LEFT)

text3 = Label(root, text="\n")
text3.pack()
if lang=="ESP":
	chatframe = LabelFrame(root, text="Chats del Team SOS. Si quieres charlar con otros usuarios, entra!", width=500)
elif lang=="ENG":
	chatframe = LabelFrame(root, text="Chats del Team SOS. Enter here if you want to talk with others users!", width=500)
chatframe.pack()
chatnds = Button(chatframe, image=photo_ndslogo_chat, command=chat_ndsos, bg="white", height=50)
chatnds.pack(side=LEFT)
chatps3 = Button(chatframe, image=photo_ps3logo_chat, command=chat_ps3sos, bg="white", height=50)
chatps3.pack(side=LEFT)
chatwii = Button(chatframe, image=photo_wiilogo_chat, command=chat_wiisos, bg="white", height=50)
chatwii.pack(side=LEFT)
chat360 = Button(chatframe, image=photo_360logo_chat, command=chat_x360sos, bg="white", height=50)
chat360.pack(side=LEFT)
root.config(menu=menubar)

root.mainloop()

